;
;  xxxx-xxx (c) COPYRIGHT IBM CORP. 1996,97   ALL RIGHTS RESERVED.
;
;                     OCO SOURCE MATERIAL
;                LICENSED MATERIALS-PROPERTY OF IBM.
;
;
; CodeStore/ice/system.ice, m.system, montana.dev
; 3/29/98 1.21 sccsid
;
;
; This is an .ice file describing extensions and their options.
;
; * Each category describes either an extension, an option group or
;   an option, as indicated by the "type" entry.
; * The optional "description" entry is for use by the UI.
; * The optional "help" entry points to the help URL.
; * The other entries depend on the type.
;
; Limitations:
;
;   1. names of options or option groups may not contain whitespace
;   2. all names (of extensions, option groups and options) must be unique.
;

;
; Option description for Windows
;


;
; CodeStore/ice/system2.txt, m.system, montana.V400, 990219b
; 3/11/99 1.10 sccsid
;



;
; CodeStore/ice/system3.txt, m.system, montana.V400, 990219b
; 3/11/99 1.10 sccsid
;








;
; CodeStore/ice/system4.txt, m.system, montana.V400, 990219b
; 3/11/99 1.2 sccsid
;


;
; CodeStore/ice/system5.txt, m.system, montana.V400, 990219b
; 3/11/99 1.2 sccsid
;



;
; CodeStore/ice/system6.txt, m.system, montana.V400, 990219b
; 3/11/99 1.2 sccsid
;


;
; CodeStore/ice/cppextension.ice, m.system, montana.V400
; 10/6/98 1.12.1.2 sccsid
;

; C++ extension

[CPlusPlus]
type=extension
description=C++ Compiler
dll=..;    dummy entry - something whose timestamp usually doesn't change
help=
suffixes=cpp CPP Cpp cxx CXX Cxx lib LIB Lib
options=CPlusPlusOptions

[CPlusPlusOptions]
type=option_group
description=Common C/C++ and C++ Only Compiler Options
help=
elements=cpp_gen cpp_lang cpp_link cpp_opt cpp_misc

[cpp_gen]
type=option_group
description=Code Generation Options
help=
elements=common_gen cpp_only_gen

[cpp_lang]
type=option_group
description=Language Options
help=
elements=common_lang cpp_only_lang

[cpp_link]
type=option_group
description=Linker Options
help=
elements=common_link cpp_only_link

[cpp_opt]
type=option_group
description=Optimization Options
help=
elements=common_opt cpp_only_opt

[cpp_misc]
type=option_group
description=Miscellaneous Options
help=
elements=common_misc cpp_only_misc

;
; C/C++ Code Generation Options Group
;


[common_gen]
type=option_group
description=Common C/C++ Code Generation Options
help=
elements=gen(arch) gen(call) gen(constseg) gen(codeseg) gen(dataseg) \
         gen(debugunreferenced) gen(decorateexternalnames) gen(dump) \
         gen(enumsize) gen(initauto) gen(libansi) gen(pack) \
         gen(parmdword) gen(profile) gen(probe) gen(readonly) \
         gen(ring0) gen(tiledmemory) gen(uninitseg) gen(unreferenced)

[cpp_only_gen]
type=option_group
description=C++ Only Code Generation Options
help=
;
elements=gen(vftreadonly) gen(vft) gen(eh) gen(ehcodeseg) gen(ehdataseg) \
         gen(manglelinkagekeywordonlyfuncs) gen(rtti) gen(vftseg)

;
; C/C++ Language Options Group
;
[common_lang]
type=option_group
description=Common C/C++ Language Options
help=
elements=lang(allowdollarinnames) lang(longlong) lang(memoryfiles) lang(signedbitfields) \
         lang(signedchars)

[cpp_only_lang]
type=option_group
description=C++ Only Language Options
help=
elements=lang(allowtypedefasclassname) lang(anonymousstructs) lang(ansiforstatementscopes) \
         lang(compatfrienddeclarations) lang(compatmath) \
         lang(compattempaccesschecking) lang(compattemplatespecialization) \
         lang(digraphs) lang(olddigraphs) \
         lang(extendedanonymousunions) lang(illformedpointertomember) \
         lang(implicitint) lang(keyword) lang(nokeyword) lang(localtypedefs) \
         lang(localusingdirectives) \
         lang(offsetofnonpodclasses) \
         lang(staticconstlinkage) lang(staticinlinelinkage) \
         lang(templatedefimpls) lang(trailingenumcommas) \
         lang(universalcharacternames) lang(zeroextentarrays)


[common_link]
type=option_group
description=Common C/C++ Link Options
help=
elements=link(debug) link(export) link(exportlist) \
         link(export_namespace) link(export_prefix) \
         link(force) \
         link(generatedfilesdirectory) link(libsearchpath) \
         link(import) link(linkwithmultithreadlib) link(linkwithsharedlib) \
         link(map) link(padding) link(standalone) link(versionstring) \
         link(ansiextensionslibrary) link(code) link(data) link(defaultlibs) \
         link(defaultlibsname) link(nodefaultlibsname) link(entry) \
         link(extdictionary) link(fixed) link(ignorecase) \
         link(include) link(linenum) link(namemangling) link(optfunc) \
         link(section) link(version) link(alignaddr) link(alignfile) \
         link(base) link(dllinitinstance) link(dllterminstance) \
         link(exepack) link(pmtype) link(robase) \
         link(stack) link(stub)

[cpp_only_link]
type=option_group
description=C++ Only Linker Options
help=
elements=link(exportall)


[common_opt]
type=option_group
description=Common C/C++ Optimization Options
help=
elements=opt(alias) opt(autoinline) opt(ignerrno) opt(inline) opt(isolatedcall) \
         opt(level) opt(pragmadisjoint) opt(pragmaisolatedcall) \
         opt(size) opt(tune) opt(float) opt(integer) opt(schedule) \
         opt(stackchaining) opt(stackpointer)

[cpp_only_opt]
type=option_group
description=C++ Only Optimization Options
help=
elements=opt(basepriority)

[common_misc]
type=option_group
description=Common C/C++ Miscellaneous Options
help=
elements=define() incl(searchpath) incl(searchpathfirst) report(level) undefine() \
         alloc(debug)

[cpp_only_misc]
type=option_group
description=C++ Only Miscellaneous Options
help=
elements=macros(global) macros(redefine) report(disable) report(enable) report(treataserror) \
         service() incl(userstrategy)

;
; CodeStore/ice/cextension.ice, m.system, montana.V400, 990219b
; 3/11/99 1.10 sccsid
;

; C extension

[CS_CExtension]
type=extension
description=C Compiler
help=
dll=cs_cext
suffixes=c C
options=CS_CExtensionOptions


[CS_CExtensionOptions]
type=option_group
description=C Only Compiler Options
help=
elements=C_compiler_name c_only_gen c_only_lang c_only_opt c_file c_pp c_list c_only_misc

; name of the C compiler

[C_compiler_name]
type=option
description=Name of C compiler
kind=string
default=iccv4.exe


; Code Generation Options

[c_only_gen]
type=option_group
description=C Only Code Generation Options
help=
elements=gen(debug) gen(lineonlydebug) gen(loadds)

; Language Options

[c_only_lang]
type=option_group
description=C Only Language Options
help=
elements=lang(cdigraphs) lang(dbcs) lang(ddnames) lang(ignobsoletekeywords) \
         lang(level) lang(preserveunsignedpromotion) \
         lang(slashslashcomments)

; Optimization Options

[c_only_opt]
type=option_group
description=C Only Optimization Options
help=
elements=opt(limitworkingset)

; File Options

[c_file]
type=option_group
description=C Only File Options
help=
elements=file(genasm) file(asmfilename) file(genasmwithcode) file(genobject) \
         file(genpch) file(usepch) file(ignoreenvincpaths) \
         file(ignoreusrincpaths) file(makedep) file(syntaxonly)

; Preprocessor Options

[c_pp]
type=option_group
description=C Only Preprocessor Options
help=
elements=pp(preprocessonly) pp(preservecomments) pp(stdout) pp(suppressline)

; List Options

[c_list]
type=option_group
description=C Only List Options
help=
elements=list(full) list(listing) list(filename) list(incsource) \
         list(expuserinc) list(expallinc) list(expmacros) \
         list(minxref) list(fullxref) list(refstructvar) list(allstructvar) \
         list(pagelen) list(title) list(subtitle)

; Miscellaneous Options

[c_only_misc]
type=option_group
description=C Only Miscellaneous Options
help=
elements=debug(maxerrors) c_info misc(optionstring) \
         misc(margins) misc(marginvalues) \
         misc(sequencenumbers) misc(sequencenumbervalues)

;
; CodeStore/ice/coptions.ice, m.system, montana.V400, 990219b
; 3/11/99 1.15 sccsid
;

;
; Code Generation Options
;

[gen(debug)]
type=option
description=Generate code for debug
help=
kind=bool
default=false


[gen(lineonlydebug)]
type=option
description=Generate debug information containing only line numbers
help=
kind=bool
default=false


[gen(loadds)]
type=option
description=Perform special handling of DS ans ES registers, for virtual device driver development
help=
kind=bool
default=false


;
; Language Options
;

[lang(cdigraphs)]
type=option
description=Allow use of digraphs
help=
kind=bool
default=false


[lang(dbcs)]
type=option
description=Allow use of DBCS
help=
kind=bool
default=false


[lang(ddnames)]
type=option
description=Allow use of ddnames
help=
kind=bool
default=false

[lang(ignobsoletekeywords)]
type=option
description=Ignore obsolete keywords
help=
kind=bool
default=false


[lang(level)]
type=option
description=Set current language level
help=
kind=enum: ansi extended saal2
ansi=0, ANSI
extended=1, Extended
saal2=2, SAA Level 2
default=extended



[lang(preserveunsignedpromotion)]
type=option
description=Preserve unsigned integer promotion
help=
kind=bool
default=false

[lang(slashslashcomments)]
type=option
description=Allow double slashes to indicate comments
help=
kind=bool

default=true



;
; Optimization Options
;


[opt(limitworkingset)]
type=option
description=Limit working set size
help=
kind=bool
default=false



;
; File Options
;

[file(genasm)]
type=option
description=Generate assembler listing file
help=
kind=bool
default=no


[file(asmfilename)]
type=option
description=Assembler listing file name
help=
kind=string
default=no

[file(genasmwithcode)]
type=option
description=Generate assembler listing file that includes machine code
help=
kind=ctrlstr
default=no


[file(genobject)]
type=option
description=Generate object file
help=
kind=ctrlstr
default=yes

[file(genpch)]
type=option
description=Generate precompiled header file
help=
kind=ctrlstr
default=no

[file(usepch)]
type=option
description=Use precompiled header file
help=
kind=ctrlstr
default=no



[file(ignoreenvincpaths)]
type=option
description=Ignore the INCLUDE environment variable
help=
kind=bool
default=false

[file(ignoreusrincpaths)]
type=option
description=Ignore the incl(searchPath, ...) option
help=
kind=bool
default=false


[file(makedep)]
type=option
description=Generate makefile dependency information
help=
kind=bool
default=false


[file(syntaxonly)]
type=option
description=Perform syntax check only
help=
kind=bool
default=false



;
; Preprocessor Options
;

[pp(preprocessonly)]
type=option
description=Run the preprocessor only
help=
kind=bool
default=false

[pp(preservecomments)]
type=option
description=Preserve source code comments in preprocessor output
help=
kind=bool
default=false

[pp(stdout)]
type=option
description=Redirect preprocessor output to stdout
help=
kind=bool
default=false

[pp(suppressline)]
type=option
description=Suppress #line directives in the preprocessor output
help=
kind=bool
default=false


;
; reserved for list() options
;

[list(listing)]
type=option
description=Produce a listing file
help=
kind=bool
default=false

[list(incsource)]
type=option
description=Include the source code
help=
kind=bool
default=false

[list(expallinc)]
type=option
description=Expand user and system #include files
help=
kind=bool
default=false

[list(minxref)]
type=option
description=Generate a minimal cross-reference table
help=
kind=bool
default=false

[list(fullxref)]
type=option
description=Generate a cross-reference table
help=
kind=bool
default=false


[list(full)]
type=option
description=Generate all listing components
help=
kind=bool
default=false

[list(filename)]
type=option
description=Listing file name
help=
kind=string
default=

[list(expuserinc)]
type=option
description=Expand user #include files
help=
kind=bool
default=false

[list(expmacros)]
type=option
description=Expand macros
help=
kind=bool
default=false

[list(refstructvar)]
type=option
description=Include a minimal layout
help=
kind=bool
default=false

[list(allstructvar)]
type=option
description=Include a layout
help=
kind=bool
default=false

[list(pagelen)]
type=option
description=Set page length of listing file
help=
kind=int
default=66

[list(title)]
type=option
description=Set title string in the listing file
help=
kind=string
default=

[list(subtitle)]
type=option
description=Set subtitle string in the listing file.
help=
kind=string
default=



; Miscellaneous Options

[debug(maxerrors)]
type=option
description=End compilation when error count reaches this value
help=
kind=int
default=0

[c_info]
type=option_group
help=
description=Generation of informational messages
elements=info(all) info(cmp) info(cnd) info(cns) info(cnv) \
          info(cpy) info(dcl) info(eff) info(enu) info(ext) \
          info(gen) info(gnr) info(got) info(ini) info(inl) \
          info(lan) info(obs) info(ord) info(par) info(por) \
          info(ppc) info(ppt) info(pro) info(rea) info(ret) \
          info(trd) info(tru) info(uni) info(use)

[info(all)]
type=option
description=All diagnostics
help=
kind=bool
default=false

[info(cmp)]
type=option
description=Possible redundancies in unsigned comparisons
help=
kind=bool
default=false

[info(cnd)]
type=option
description=Possible redundancies or problems in conditional expressions
help=
kind=bool
default=true

[info(cns)]
type=option
description=Operations involving constants
help=
kind=bool
default=false

[info(cnv)]
type=option
description=Conversions
help=
kind=bool
default=false

[info(cpy)]
type=option
description=Problems generating copy constructors
help=
kind=bool
default=false

[info(dcl)]
type=option
description=Consistency of declarations
help=
kind=bool
default=false

[info(eff)]
type=option
description=Statments with no effect
help=
kind=bool
default=false

[info(enu)]
type=option
description=Consistency of enum variables
help=
kind=bool
default=false

[info(ext)]
type=option
description=Unused external definitions
help=
kind=bool
default=false

[info(gen)]
type=option
description=General diagnostics
help=
kind=bool
default=false

[info(gnr)]
type=option
description=Generation of temporary variables
help=
kind=bool
default=false

[info(got)]
type=option
description=Usage of "goto" statement
help=
kind=bool
default=false

[info(ini)]
type=option
description=Possible problems with initialization
help=
kind=bool
default=false

[info(inl)]
type=option
description=Functions not inlined
help=
kind=bool
default=false

[info(lan)]
type=option
description=Effects of the language level
help=
kind=bool
default=false

[info(obs)]
type=option
description=Features that are obsolete
help=
kind=bool
default=false

[info(ord)]
type=option
description=Unspecified order of evaluation
help=
kind=bool
default=false

[info(par)]
type=option
description=Unused parameters
help=
kind=bool
default=false

[info(por)]
type=option
description=Nonportable language constructs
help=
kind=bool
default=false

[info(ppc)]
type=option
description=Possible problems with using the preprocessor
help=
kind=bool
default=false

[info(ppt)]
type=option
description=Trace of preprocessor actions
help=
kind=bool
default=false

[info(pro)]
type=option
description=Missing function prototypes
help=
kind=bool
default=true

[info(rea)]
type=option
description=Code that cannot be reached
help=
kind=bool
default=false

[info(ret)]
type=option
description=Consistency of "return" statements
help=
kind=bool
default=true

[info(trd)]
type=option
description=Possible trancation or loss of data or precision
help=
kind=bool
default=false

[info(tru)]
type=option
description=Variable names truncated by the compiler
help=
kind=bool
default=false

[info(uni)]
type=option
description=Uninitialized variables
help=
kind=bool
default=false

[info(use)]
type=option
description=Unused "auto" and "static" variables
help=
kind=bool
default=false

[misc(optionstring)]
type=option
description=Command line options to be appended
help=
kind=string
cumulative=yes


[misc(margins)]
type=option
description=Use margins setting when processing source files
help=
kind=bool
default=false

[misc(marginvalues)]
type=option
description=Margin values
help=
kind=struct

  [misc(marginvalues).1]
  type=option
  description=Left margin
  kind=int
  default=1

  [misc(marginvalues).2]
  type=option
  description=Right margin
  kind=int
  default=65535
  optional=yes

[misc(sequencenumbers)]
type=option
description=Use sequence numbers setting when processing source files
help=
kind=bool
default=false

[misc(sequencenumbervalues)]
type=option
description=Sequence number values
help=
kind=struct

  [misc(sequencenumbervalues).1]
  type=option
  description=Left sequence number boundary
  kind=int
  default=1

  [misc(sequencenumbervalues).2]
  type=option
  description=Right sequence number boundary
  kind=int
  default=65535
  optional=yes


; End of File CodeStore/ice/coptions.ice, m.system, montana.V400, 990219b

; End of File CodeStore/ice/cextension.ice, m.system, montana.V400, 990219b

;
; CodeStore/ice/cppgen.ice, m.system, montana.V400
; 7/13/98 1.11 sccsid
;

;
; C/C++ Code Generation Options
;


[gen(arch)]
type=option
description=Target CPU architecture for instruction set selection
help=
kind=enum: x86 486 pentium pentium2
x86=0, Target Intel x86 processors
486=1, Target Intel 486 processor
pentium=2, Target Intel Pentium processor
pentium2=3, Target Intel Pentium II processor
default=486



[gen(debugunreferenced)]
type=option
description=Produce symbol table for unreferenced variables
help=
kind=bool
default=false

[gen(enumsize)]
type=option
description=Enum variable size
help=
kind=enum: int small 1 2 4
small=0, Small
int=10
1=1
2=2
4=4
default=small

[gen(initauto)]
type=option
description=Initialize automatic storage
help=
kind=ctrlint
default=no

[gen(libansi)]
type=option
description=Treat ANSI C library names as system functions
help=
kind=bool
default=false

[gen(profile)]
type=option
description=Enable code for performance analysis
help=
kind=enum: no yes
no=0, No
yes=1, Yes
default=no

[gen(readonly)]
type=option
description=Use read-only storage for string literals
help=
kind=bool
default=true

[gen(vftreadonly)]
type=option
description=VFT in read-only storage
help=
kind=bool
default=false

[gen(vft)]
type=option
description=Generate VFT in compilation unit
help=
kind=bool
default=true



[gen(pack)]
type=option
description=Alignment of data items within structures and unions
help=
kind=enum: 1 2 4 8 16
1=1
2=2
4=4
8=8
16=16
default=4



[gen(call)]
type=option
description=Default calling convention
help=
kind=enum: optlink system stdcall cdecl
optlink=0
system=1
stdcall=2
cdecl=3
default=optlink

[gen(constseg)]
type=option
description=Default constant segment name
help=
kind=string
default=CONST32_RO

[gen(codeseg)]
type=option
description=Default code segment name
help=
kind=string
default=CODE32

[gen(dataseg)]
type=option
description=Default data segment name
help=
kind=string
default=DATA32

[gen(dump)]
type=option
description=Provide a register dump when an exception occurs
help=
kind=bool
default=false

[gen(probe)]
type=option
description=Use stack probes
help=
kind=bool
default=true

[gen(uninitseg)]
type=option
description=Uninitialized data segment name
help=
kind=string
default=BSS32

[gen(unreferenced)]
type=option
description=Generate code for unreferenced functions
help=
kind=bool
default=false

[gen(eh)]
type=option
description=Enable C++ exception handling
help=
kind=bool
default=true
global=yes

[gen(ehcodeseg)]
type=option
description=Exception handling code segment name
help=
kind=string
default=EH_CODE

[gen(ehdataseg)]
type=option
description=Exception handling data segment name
help=
kind=string
default=EH_DATA

[gen(manglelinkagekeywordonlyfuncs)]
type=option
description=Mangle names of functions that have linkage keywords, but no linkage strings
help=
kind=bool
default=true
global=yes

[gen(vftseg)]
type=option
description=Virtual function table segment name
help=
kind=string
default=_VFT


; all platforms

[gen(rtti)]
type=option
description=Generation of run-time type information
help=
kind=enum: all typeinfo dynamiccast no
no=0, No run-time type information
all=1, Both typeid and dynamic_cast information
typeinfo=2, Only typeid information
dynamiccast=3, Only dynamic_cast information
default=no
global=yes



[gen(decorateexternalnames)]
type=option
description=Decorate all external data names with a leading underscore
help=
kind=bool
default=false
global=yes

[gen(parmdword)]
type=option
description=Enable support for __parmdwords()
help=
kind=bool
default=false

[gen(ring0)]
type=option
description=Generate code to run in ring 0
help=
kind=bool
default=false

[gen(tiledmemory)]
type=option
description=Enable tiled memory
help=
kind=bool
default=false



;
; CodeStore/ice/cpplang.ice, m.system, montana.V400, 990219b
; 3/11/99 1.6 sccsid
;

;
; C/C++ Language Options
;


[lang(allowdollarinnames)]
type=option
description=Allow $ in names
help=
kind=bool
default=false

[lang(digraphs)]
type=option
description=Allow digraph and keyword operators
help=
kind=bool
default=true

[lang(longlong)]
type=option
description=Allow long long int type
help=
kind=bool
default=true

[lang(signedbitfields)]
type=option
description=Treat bitfields as signed
help=
kind=bool
default=false

[lang(signedchars)]
type=option
description=Treat char variables as signed
help=
kind=bool
default=false

[lang(allowtypedefasclassname)]
type=option
description=Allow "typedeffed" as class name
help=
kind=bool
default=false

[lang(anonymousstructs)]
type=option
description=Allow anonymous structs
help=
kind=bool
default=true

[lang(ansiforstatementscopes)]
type=option
description=Variables declared in for-init-statements are only visible within the loop
help=
kind=bool
default=true

[lang(compatfrienddeclarations)]
type=option
description=Allow friend declarations without elaborated classnames
help=
kind=bool
default=true

[lang(compatmath)]
type=option
description=New ANSI math function declarations
help=
kind=bool
default=false

[lang(compattempaccesschecking)]
type=option
description=Suppress copy-constructor access checking for eliminated temporaries
help=
kind=bool
default=true

[lang(compattemplatespecialization)]
type=option
description=Allow template specializations without preceding "template <>"
help=
kind=bool
default=true

[lang(extendedanonymousunions)]
type=option
description=Allow non-data members in anonymous unions
help=
kind=bool
default=true

[lang(illformedpointertomember)]
type=option
description=Allow ill-formed pointer to member expressions
help=
kind=bool
default=true

[lang(implicitint)]
type=option
description=Allow implicit int
help=
kind=bool
default=true

[lang(nokeyword)]
type=option
description=Ignore the specified keyword
help=
kind=string
cumulative=yes

[lang(keyword)]
type=option
description=Reinstate the specified keyword
help=
kind=string
cumulative=yes

[lang(localtypedefs)]
type=option
description=Typedefs visible from the primary source only
help=
kind=bool
default=false

[lang(localusingdirectives)]
type=option
description=Using directive applies locally to the source file
help=
kind=bool
default=false

[lang(offsetofnonpodclasses)]
type=option
description=Allow offsetof() to be used with non-POD ("plain ol' data") classes
help=
kind=bool
default=true

[lang(olddigraphs)]
type=option
description=Allow %% and %%%% as digraphs
help=
kind=bool
default=false

[lang(staticconstlinkage)]
type=option
description=Treat constant variables as static
help=
kind=bool
default=false

[lang(staticinlinelinkage)]
type=option
description=Treat inline functions as static
help=
kind=bool
default=false

[lang(templatedefimpls)]
type=option
description=Control the parsing and semantic checking of template implementations
help=
kind=enum: dontparse parsewithwarnings parsewitherrors
dontparse=0, Do not parse template implementations
parsewithwarnings=2, Parse template implementations and issue semantic warnings
parsewitherrors=3, Parse template implementations and issue semantic errors
default=parsewithwarnings

[lang(trailingenumcommas)]
type=option
description=Allow trailing commas for enumerations
help=
kind=bool
default=true

[lang(universalcharacternames)]
type=option
description=Universal character names
help=
kind=bool
default=true

[lang(zeroextentarrays)]
type=option
description=Allow zero-extent arrays
help=
kind=bool
default=true


[lang(memoryfiles)]
type=option
description=Allow use of memory files
help=
kind=bool
default=false


;
; CodeStore/ice/cpplink.ice, m.system, montana.V400
; 8/11/98 1.17 sccsid
;

;
; C/C++ Linker Options
;



[link(export_namespace)]
type=option
description=Export all defined external symbols in the namespace
help=
kind=string
default=

[link(export_prefix)]
type=option
description=Export all defined external symbols that start with the prefix 
help=
kind=string
default=

[link(entry)]
type=option
description=Entry point of the executable output file
help=
kind=string
default=

[link(pmtype)]
type=option
kind=enum: novio vio pm
description=OS/2 mode of execution
pm=768
vio=512
novio=256
default=vio


[link(debug)]
type=option
description=Include debug information in the generated executable module
help=
kind=bool
default=false

[link(export)]
type=option
description=Export specified symbol from the target
kind=struct
cumulative=yes

  [link(export).1]
  type=option
  kind=string
  description=Function name

  [link(export).2]
  type=option
  kind=string
  description=Actual name of the export function or data item
  optional=yes


  [link(export).3]
  type=option
  kind=int
  description=Function ordinal position within the module definition table
  optional=yes
  default=0

  [link(export).4]
  type=option
  kind=enum: NONAME RESIDENTNAME
  description=Specify "NONAME" to indicate that the function name is not to be kept
  NONAME=1
  RESIDENTNAME=0
  default=RESIDENTNAME



  [link(export).5]
  type=option
  kind=enum: CONSTANT PARMWORDS
  description=Exported name is a data item
  CONSTANT=1
  PARMWORDS=0
  default=CONSTANT

  [link(export).6]
  type=option
  kind=int
  description=Total size of function's parameters in words
  optional=yes
  default=0


[link(exportlist)]
type=option
description=File containing export specifications
help=
kind=file

[link(force)]
type=option
description=Ignore unresolved reference errors
help=
kind=bool
default=false

[link(generatedfilesdirectory)]
type=option
description=Directory for extra generated files
help=
kind=string
cumulative=no

[link(libsearchpath)]
type=option
description=Library search path
help=
kind=string
cumulative=yes

[link(import)]
type=option
description=Import specified symbol from a DLL
help=
kind=struct
cumulative=yes

  [link(import).1]
  type=option
  kind=string
  description=Imported symbol
  optional=no

  [link(import).2]
  type=option
  kind=string
  description=Exporting program name
  optional=no

  [link(import).3]
  type=option
  kind=union
  description=Symbol

    [link(import).3.1]
    type=option
    kind=string
    description=Symbol from the exporting program

    [link(import).3.2]
    type=option
    kind=int
    description=Symbol's ordinal position within the module definition table
    default=0

  ;3=union
    ;3.1=string, , symbol from the exporting program
    ;3.2=int, , symbol's ordinal position within the module definition table

[link(linkwithmultithreadlib)]
type=option
description=Link target with multi-thread libraries
help=
kind=bool
default=false

[link(linkwithsharedlib)]
type=option
description=Link target with the shared libraries
help=
kind=bool
default=false

[link(map)]
type=option
description=Generate a map file
help=
kind=ctrlstr
default=no

[link(padding)]
type=option
description=Add information to targets for faster rebuilds
help=
kind=bool
default=true

[link(standalone)]
type=option
description=Generate code for standalone subsystem
help=
kind=bool
default=false

[link(versionstring)]
type=option
description=Version string embedded in the target
help=
kind=string
default=

[link(exportall)]
type=option
description=Export all defined external symbols
help=
kind=bool
default=false



[link(ansiextensionslibrary)]
type=option
description=Control the use of extended library containing non-ANSI extensions
help=
kind=bool
default=true



[link(data)]
type=option
help=
kind=attrib: RWSADIGHL
description=Default attributes for all data sections
default=RW
R=read
W=write
S=shared
A=16:16 alias
D=discardable
I=i/o privilege
G=resident and contiguous
H=resident and long-lockable
L=resident



[link(code)]
type=option
help=
kind=attrib: REXSACDIGHL
description=Default attributes for all code sections
default=RX
R=read
E=execute
X=execute
S=shared
A=16:16 alias
C=conforming
D=discardable
I=i/o privilege
G=resident and contiguous
H=resident and long-lockable
L=resident

[link(defaultlibs)]
type=option
description=Search all default libraries
help=
kind=bool
default=true

[link(defaultlibsname)]
type=option
description=Add the specified name to the list of default libraries
help=
kind=string
cumulative=yes

[link(nodefaultlibsname)]
type=option
description=Add the specified name to the list of default libraries not to be searched
help=
kind=string
cumulative=yes

[link(extdictionary)]
type=option
description=Use library extended dictionaries to resolve intermodule dependency information
help=
kind=bool
default=true

[link(fixed)]
type=option
description=Disable module relocation at load time
help=
kind=bool
default=false
;default=depends on the executable types

[link(ignorecase)]
type=option
description=Ignore case when searching for unresolved symbols
help=
kind=bool
default=false
global=yes

[link(include)]
type=option
description=Force a reference to the specified symbol
help=
kind=string
cumulative=yes

[link(linenum)]
type=option
description=Add line number information to the map file
help=
kind=bool
default=false

[link(namemangling)]
type=option
description=Maximum length of mangled names
help=
kind=enum: compat ansi
compat=0, 255 characters with 3 characters hashing
ansi=1, 64000 characters with 9 characters hashing
default=0

[link(optfunc)]
type=option
description=Remove unreachable functions from external objects
help=
kind=bool
default=true



[link(section)]
type=option
description=Memory-protection attributes for the named sections
help=
kind=struct
cumulative=yes

  [link(section).1]
  type=option
  kind=string
  description=Segment name

  [link(section).2]
  type=option
  help=
  kind=attrib: RWEXSACDIGHL
  description=Attributes
  default=RX
  R=read
  W=write
  E=execute
  X=execute
  S=shared
  A=16:16 alias
  C=conforming
  D=discardable
  I=i/o privilege
  G=resident and contiguous
  H=resident and long-lockable
  L=resident

[link(version)]
type=option
description=Include user version number in the target
help=
kind=struct

  [link(version).1]
  type=option
  kind=int
  description=Major version number
  default=0

  [link(version).2]
  type=option
  kind=int
  description=Minor version number
  optional=yes
  default=0




[link(alignaddr)]
type=option
description=Section address alignment
help=
kind=int, ,address alignment
default=0x10000

[link(alignfile)]
type=option
description=File alignment for sections
help=
kind=int, ,address alignment
default=16

[link(base)]
type=option
description=Default base address for the target
help=
kind=int
default=65536

[link(dllinitinstance)]
type=option
description=The DLL initialization function should be called for each instance
help=
kind=bool
default=false

[link(dllterminstance)]
type=option
description=The DLL termination function should be called for each instance
help=
kind=bool
default=false

[link(exepack)]
type=option
kind=enum: 0 1 2
description=Executable compression
0=0
1=1
2=2
default=2

[link(robase)]
type=option
description=Default base address for the non writable segments
help=
kind=int
default=0

[link(stack)]
type=option
description=Maximum stack size
help=
kind=struct

  [link(stack).1]
  type=option
  kind=int
  description=Total virtual address space reserved
  default=0

  [link(stack).2]
  type=option
  kind=int
  description=Initial allocated storage size
  default=0
  optional=yes

[link(stub)]
type=option
description=Prepend the default stub to the target
help=
kind=ctrlstr
default=yes


;
; CodeStore/ice/cppopt.ice, m.system, montana.V400, 990219b
; 3/11/99 1.6 sccsid
;


;
; C/C++ Optimization Options
;

[opt(alias)]
type=option_group
description=Aliasing rules for optimization
help=
elements=opt(alias,allp) opt(alias,typ) opt(alias,addr) opt(alias,ansi)

[opt(alias,allp)]
type=option
description=Pointers are never aliased
help=
kind=bool
default=false

[opt(alias,typ)]
type=option
description=Pointers to different types are never aliased
help=
kind=bool
default=false

[opt(alias,addr)]
type=option
description=Variables are disjoint from pointers
help=
kind=bool
default=false

[opt(alias,ansi)]
type=option
description=use type-based aliasing
help=
kind=bool
default=false

[opt(autoinline)]
type=option
description=Perform automatic inlining
help=
kind=bool
;if opt(level)>0 default should be true
default=false

[opt(ignerrno)]
type=option
description=Ignore error number
help=
kind=bool
default=false

[opt(inline)]
type=option
description=Inline specified user functions
help=
kind=bool
default=false

[opt(ipa)]
type=option
description=Use IPA optimizer
help=
kind=bool
default=false

[opt(ipaoption)]
type=option
description=Set IPA option
help=
kind=string
cumulative=yes

[opt(isolatedcall)]
type=option
description=Isolated call function names
help=
kind=string
cumulative=yes


[opt(level)]
type=option
description=Optimization
help=
kind=enum: 0 2
0=0, No
2=2, Yes
default=0



[opt(pragmadisjoint)]
type=option
description=Honor references to #pragma disjoint
help=
kind=bool
default=true

[opt(pragmaisolatedcall)]
type=option
description=Honor references to #pragma isolatedcall
help=
kind=bool
default=true

;
;[opt(profileDirectedFeedback)]
; 

[opt(size)]
type=option
description=Optimize code for size
help=
kind=bool
default=false


[opt(tune)]
type=option
description=Target CPU for code optimization
help=
kind=enum: blend 386 486 pentium pentium2
blend=0, Target Intel x86 processors
386=2, Target Intel 386 processor
486=3, Target Intel 486 processor
pentium=4, Target Intel Pentium processor
pentium2=5, Target Intel Pentium II processor
default=blend



[opt(basepriority)]
type=option
description=Base priority for runtime static initialization
help=
kind=int
default=0

[opt(autoinlinethreshold)]
type=option
description=Threshold number of intermediate language instructions for auto-inlining
help=
kind=int
default=0



[opt(float)]
type=option
description=Use fast floating-point execution
help=
kind=bool
default=true

[opt(integer)]
type=option
description=Use fast integer execution
help=
kind=bool
default=true

[opt(schedule)]
type=option
description=Invoke instruction scheduler
help=
kind=bool
default=false
;default=depends on other opt() values

[opt(stackchaining)]
type=option
description=Control stack chaining
help=
kind=bool
default=false
; default based on opt(level)

[opt(stackpointer)]
type=option
description=Stack pointer optimization
help=
kind=bool
default=true

;
; CodeStore/ice/cppmisc.ice, m.system, montana.V400, 990219b
; 3/11/99 1.3 sccsid
;

;
; C/C++ Miscellaneous Options
;

[define()]
type=option
description=Define macros
help=
kind=struct
cumulative=yes

  [define().1]
  type=option
  description=Macro name
  kind=string

  [define().2]
  type=option
  description=Macro value
  kind=string
  optional=yes

[incl(searchpath)]
type=option
description=Set #include search path
help=
kind=incpath
cumulative=yes

[incl(searchpathfirst)]
type=option
description=Search first directories specified above
help=
kind=bool
default=false

[report(level)]
type=option
description=Set minimum severity level of build messages
help=
kind=enum: E W I
E=0, Error
W=1, Warning
I=2, Informational
default=I

[undefine()]
type=option
description=Undefine macros
help=
kind=string
cumulative=yes

[macros(global)]
type=option
description=Set global scope for macros
help=
kind=bool
default=false

[macros(redefine)]
type=option
description=Enable macro redefinition without prior #undef or 'undefine()'
help=
kind=bool
default=false

[report(enable)]
type=option
description=Enable the generation of the specified message
help=
kind=string
cumulative=yes

[report(disable)]
type=option
description=Suppress the generation of the specified message
help=
kind=string
cumulative=yes

[report(treataserror)]
type=option
description=Treat this message number as error
help=
kind=string
cumulative=yes

[service()]
type=option
description=Pass this string to the compiler
help=
kind=string
cumulative=yes

[incl(userstrategy)]
type=option
description=Search strategy for user include files
help=
kind=enum: primary including
primary=1, Primary
including=2, Including
default=primary

;
;


[alloc(debug)]
type=option
description=Enable debug version of memory management functions
help=
kind=bool
default=false

;
;  xxxx-xxx (c) COPYRIGHT IBM CORP. 1997   ALL RIGHTS RESERVED.
;
;                     OCO SOURCE MATERIAL
;                LICENSED MATERIALS-PROPERTY OF IBM.
;
;
; CodeStore/ice/NT/SQLEextension.ice
; Sep 04/97 Kelvin Ho
;
;
; This is an .ice file describing the SQL Extension.
;
; * Each category describes either an extension, an option group or
;   an option, as indicated by the "type" entry.
; * The optional "description" entry is for use by the UI.
; * The optional "help" entry points to the help URL.
; * The other entries depend on the type.
;
; Limitations:
;
;   1. names of options or option groups may not contain whitespace
;   2. all names (of extensions, option groups and options) must be unique.
;

[CS_SQLExtension]
type=extension
className=CS_SQLExtension
dll=cs_sql
description=Embedded SQL Precompilation
help=
suffixes=sqc sqx sqC sqX SQC SQX
options=CS_SQLExtensionOptions

[CS_SQLExtensionOptions]
type=option_group
description=SQL Precompilation Options
help=
elements=SQLTargetDB SQLConnOptions SQLPrepOptions SQLPromptEnabled


[SQLTargetDB]
type=option
description=Target database name
kind=string
default=

[SQLConnOptions]
type=option
description=Database connect options
kind=string
default=

[SQLPrepOptions]
type=option
description=Precompiler options
kind=string
default=

[SQLPromptEnabled]
type=option
description=Prompt for user ID and password when necessary
kind=bool
default=true

;
; CodeStore/ice/resource.ice, m.system, montana.V400, 990219b
; 3/11/99 1.6 sccsid
;

;
; Resource Compiler
;

[CS_Resource]
type=extension
description=Resource Compiler
help=ResourceExtension.html
dll=cs_res
suffixes=rc RC res RES
options=CS_ResourceOptions

[CS_ResourceOptions]
type=option_group
description=Resource Compiler Options
help=ResourceExtension.html#options
elements=res_compiler res_rc_options

[res_compiler]
type=option
description=Name of resource compiler
kind=string
default=rc.exe

[res_rc_options]
type=option
description=Options passed to the resource compiler
kind=string



;
; CodeStore/ice/partsobj.ice, m.system, montana.V400, 990219b
; 3/11/99 1.1 sccsid
;

;
; Parts Object Extension
;

[PartsObject]
type=extension
description=Part Object
dll=iprtv.dll
suffixes=vbf VBF vbe VBE
;
; CodeStore/ice/dax.ice, m.system, montana.V400, 990219b
; 3/11/99 1.1 sccsid
;

;
; DAX Extension
;

[DaxSession]
type=extension
description=Dax Session Object
dll=iprtv.dll
suffixes=dax DAX

;
; CodeStore/ice/miscext.ice, m.system, montana.V400, 990219b
; 3/11/99 1.14 sccsid
;

;
; Misc Extensions
;



;Make Generic Extension
[gen_make]
type=extension
className=CS_Generic
dll=csgenric
description=Make Program Maintenance Utility
help=
suffixes=mak MAK
prefix=generic
command=$1 $2 -f $s $3
1=make_name
2=make_preopt
3=make_postopt
options=make_options
track=$
when=precompile

[make_options]
type=option_group
description=Make Program Maintenance Utility Options
help=
elements=make_name make_preopt make_postopt

[make_name]
type=option
kind=string
description=Executable name for make utility
default=nmake
help=

[make_preopt]
type=option
kind=string
description=Leading options for make utility
default=
help=

[make_postopt]
type=option
kind=string
description=Trailing options for make utility
default=
help=
;end of Make Generic Extension


;IPFC Generic Extension
[gen_ipf]
type=extension
className=CS_Generic
dll=csgenric
description=Information Processing Facility Compiler (IPFC)
help=
suffixes=ipf IPF
prefix=generic
command=ipfc.exe $1 $s $2
1=ipf_preopt
2=ipf_postopt
3=ipf_output
options=ipf_options
track=$s
output=$3
when=precompile

[ipf_options]
type=option_group
description=Information Processing Facility Compiler (IPFC) Options
help=
elements=ipf_preopt ipf_postopt ipf_output

[ipf_preopt]
type=option
description=Leading options for IPFC
help=
kind=string
default=

[ipf_postopt]
type=option
kind=string
description=Trailing options for IPFC
default=
help=

[ipf_output]
type=option
kind=string
description=Target file type for recompile check (hlp or inf)
default=hlp
help=
;end IPFC Generic Extension

[config_opt]
type=extension
className=CS_ConfigurationOptimizer
description=Configuration Optimizer
dll=cscfgopt
help=
prefix=config

;MKMSGF Generic Extension
[gen_mkmsgf]
type=extension
className=CS_Generic
dll=csgenric
description=Make Message File Utility (MKMSGF)
help=
suffixes=mkmsgf MKMSGF
prefix=generic
command=mkmsgf.exe $s $o $1
1=mkmsgf_postopt
options=mkmsgf_options
track=$s
output=msg
when=prelink

[mkmsgf_options]
type=option_group
description=MKMSGF Options
help=
elements=mkmsgf_postopt

[mkmsgf_postopt]
type=option
kind=string
description=Trailing options for MKMSGF
default=
help=
;end MKMSGF Generic Extension

;MSGBIND Generic Extension
[gen_msgbind]
type=extension
className=CS_Generic
dll=csgenric
description=Bind message file
help=
suffixes=msgbind MSGBIND
prefix=generic
command=msgbind.exe $s
when=postlink
;end MSGBIND Generic Extension

;
; DLLRNAME
;

[CS_DLLRNAME_EXT]
type=extension
className=CS_Generic
description=Dllrname extension
help=
dll=csgenric.dll
suffixes=exe EXE dll DLL
when=postlink
command=dllrname.exe $s $1 $2
1=rename_list
2=dllrname_options
options=CS_DLLRNAMEOptions
track=$s

[CS_DLLRNAMEOptions]
type=option_group
description=Dllrname Options
help=
elements=rename_list dllrname_options

[rename_list]
type=option
description=DLLRNAME rename list
kind=string
default=

[dllrname_options]
type=option
description=Flags for DLLRNAME
kind=string
default=

;
; CodeStore/ice/config.ice, m.system, montana.V400, 990219b
; 3/11/99 1.1 sccsid
;

;
; Configuration Options
;

[config_ext]
type=extension
description=CONFIG
dll=..;    dummy entry - something whose timestamp usually doesn't change
help=
options=config_opts

[config_opts]
type=option_group
description=Configuration Options
help=
elements=defaults()

[defaults()]
type=option
kind=string
description=Set group for overriding default options
default=
